<?php

use Tygh\Registry;

if (!defined('BOOTSTRAP')) { die('Access denied'); }

if ($_SERVER['REQUEST_METHOD'] == 'POST') {
    
    $suffix = '';

   if ($mode == 'm_update_dreamkas') {
        foreach ($_REQUEST['order_ids'] as $v) {
            $dk_id = db_get_field("SELECT dk_id FROM ?:orders WHERE order_id = ?i", $v);
            if($dk_id) {
                $cheque_info = fn_dk_get_operation_status($dk_id);
                if(!empty($cheque_info)) {
                    $data = array(
                        'dk_id' => $cheque_info['id'],
                        'dk_timestamp' => strtotime(empty($cheque_info['createdAt'])?$cheque_info['completedAt']:$cheque_info['createdAt']),
                        'dk_status' => $cheque_info['status'],
                    );

                    db_query("UPDATE ?:orders SET ?u WHERE order_id = ?i", $data, $v);
                }
            }
        }
        return array(CONTROLLER_STATUS_OK, 'orders.manage' . $suffix);
   }
   
   if ($mode == 'update_dreamkas') {
        $dk_id = db_get_field("SELECT dk_id FROM ?:orders WHERE order_id = ?i", $_REQUEST['order_id']);
        if($dk_id) {
            $cheque_info = fn_dk_get_operation_status($dk_id);
        } else {
            $order_info = fn_get_order_info($_REQUEST['order_id']);
            $cheque_info = fn_dk_post_cheque($order_info);
        }
        
        if(!empty($cheque_info)) {
            $data = array(
                'dk_id' => $cheque_info['id'],
                'dk_timestamp' => strtotime(empty($cheque_info['createdAt'])?$cheque_info['completedAt']:$cheque_info['createdAt']),
                'dk_status' => $cheque_info['status'],
            );

            db_query("UPDATE ?:orders SET ?u WHERE order_id = ?i", $data, $_REQUEST['order_id']);
        }
        
        $suffix = ".details?order_id=$_REQUEST[order_id]";
        
        return array(CONTROLLER_STATUS_OK, 'orders' . $suffix);
    }
}

if($mode == 'details') {
    
    $order_info = Tygh::$app['view']->getTemplateVars('order_info');
    $settings = Registry::get('addons.dreamkas');
    $order_id = $order_info['order_id'];
    $payment_id = $order_info['payment_id'];
    $payment_ids = array_keys($settings['payments_ids']);

    if (in_array($order_info['status'],array('P','C')) && !empty($payment_ids) && in_array($payment_id, $payment_ids)) {
        $dk_id = db_get_field("SELECT dk_id FROM ?:orders WHERE order_id = ?i", $order_id);
        
        if(empty($dk_id)) {
            $cheque_info = fn_dk_post_cheque($order_info);
        } else {
            $cheque_info = fn_dk_get_operation_status($dk_id);
        }
        
        if(!empty($cheque_info['id'])){
            $data = array(
                'dk_id' => $cheque_info['id'],
                'dk_timestamp' => strtotime($cheque_info['createdAt']),
                'dk_status' => $cheque_info['status'],
            );
            db_query("UPDATE ?:orders SET ?u WHERE order_id = ?i", $data, $order_id);
        }
    }
    
}